<?
require_once('vkontakte.class.php');
require_once('config.php');
require_once("simpledb.php");
connect($conf);

class SectionParser {
  private $vk;
  private $res;
  private $list_url = "http://vkontakte.ru/market.php?act=list";
  private $country = array(1); //для каких стран ищем объявы: 1 - россия
  
  public function __construct(&$_vk) {
    $this->vk = $_vk;
  }
  
  protected function setSectionList() {
    $html = $this->vk->getPageText($this->list_url);
    $sStart = '<div id="categoriesList" class="clearFix">';
    $sStop = '</table>';
    $start = mb_strpos($html, $sStart);
    $html = mb_substr($html, $start);
    $stop = mb_strpos($html, $sStop);
    $html = mb_substr($html, 0, $stop);

    $this->res = new DOMDocument();
    @$this->res->loadHTML($html);
    $hrefs = $this->res->getElementsByTagName('a');
    $sections = array();
    foreach($hrefs as $href) {
      $sections[$href->getAttribute('href')] = utf8_decode($href->nodeValue);
    }
    return $sections;
  }
  
  public static function getSectionIdByName($name) {
    return element(sprintf("SELECT id FROM `section` WHERE `name` = '%s'", mysql_real_escape_string($name)));
  }
  
  public static function getHrefInfo($href) {
    $hs = explode("&", $href);
    $nodes = array();
    foreach($hs as $h) {
      $n = explode("=",$h);
      $nodes[$n[0]] = $n[1];
    }
    return $nodes;
  }
  
  protected function createSection($href, $name) {
    /*gsearch.php?from=ads&section=ads&c[type]=2&c[country]=1
      gsearch.php?from=ads&section=ads&c[type]=2&c[category]=14&c[country]=1*/
    $id = self::getSectionIdByName($name);
    if(!empty($id)) return $id;
    
    $info = self::getHrefInfo($href);
    $section = intval($info['c[category]']);
    if(empty($section)) $section = "NULL";
    query(sprintf("INSERT INTO `section` (`sid`, `type`, `country`, `href`, `name`) VALUES(%s, %u, %u, '%s', '%s')",
          $section,
          intval($info['c[type]']),
          intval($info['c[country]']),
          mysql_real_escape_string($href),
          mysql_real_escape_string($name)));
    return mysql_insert_id();
  }
  
  protected function write2db($sections) {
    $ids = array();
    foreach($sections as $href=>$value) {
      foreach($this->country as $country) {
        $ids[] = self::createSection($href."&c[country]=".$country, $value);
      }
    }
    return $ids;
  }
  
  public function execute() {
    $sections = $this->setSectionList();
    return $this->write2db($sections);
  }
}

class ElemntsList {
  private $section;
  private $start;
  private $vk;
  public static $moth = array("янв", "фев", "мар", "апр", "май", "июнь", "июль", "авг", "сент", "окт", "нояб", "дек"); //не знаю точно
  private $time;
  private $time_refresh = 10800; //парсим разделы, которые обновлялись позднее 3 часов назад (чтобы не тратить время на повторные проверки)
  public  $refresh_time; //время на парсинг одной серии элементов (задается из вне)
  private $vk_url = "http://vkontakte.ru/";
  private $cur_thread;
  private $cnt_thread;
  private $img_root = "images";
  private $ads_count;
  private $cur_ads_count;

  public function __construct(&$vk, $cur_thread, $cnt_thread, $ads_count) {
    $this->vk = $vk;
    $this->start = time();
    $this->cnt_thread = $cnt_thread;
    $this->cur_thread = $cur_thread;
    $this->ads_count = $ads_count;
    $this->cur_ads_count = element('SELECT COUNT(*) FROM `element`');
  }
  
  public static function getDateFromString($sdate) {
    if(mb_strpos($sdate, "сегодня") !== false) {
      //сегодня в 20:32
      list($d, $m, $y) = explode("-", date("d-m-Y"));
      $p = explode(" ", $sdate);
      $time = $p[2];
    } elseif(mb_strpos($sdate, "вчера") !== false) {
      //вчера в 20:24
      list($d, $m, $y) = explode("-", date("d-m-Y", time()-3600*24));
      $p = explode(" ", $sdate);
      $time = $p[2];
    } else {
      //10 фев в 21:59
      $pies = explode(" ", $sdate);
      $d = $pies[0];
      $m = array_search(trim($pies[1]), self::$moth)+1;
      if($m > date('m')||($m==date('m')&&$d>date('d'))) {
        $y = date('Y')-1;
      } else {
        $y = date('Y');
      }
      $time = $pies[3];
    }
    list($h, $i) = explode(":", $time);
    return date("Y-m-d H:i:s" ,mktime(intval($h), $i, 0, $m, $d, $y));
  }
  
  protected function getElementsList($html) {
      $href = array();
      $cats = array();
      $info = "";
      preg_match_all("|<div class=\"title\"><a href=\"(.+)\">|U", $html, $href);
      preg_match_all("|<div class=\"category\">(.+)</div>|U", $html, $cats);
      
      $sections = array();
      foreach($cats[1] as $k=>$cat) {
        //</a> сегодня в 13:44 | Орел
        $info = strip_tags(mb_substr($cat, mb_strrpos($cat, "</a>")));
        $info = explode("|", $info);
        
        $sections[] = array('href' => $href[1][$k],
                            'date' => trim($info[0]),
                            'city' => trim($info[1]));
      }
      return $sections;
  }
  
  protected function getElementInfo($href) {
    $this->checkTime();
    $html = $this->vk->getPageText($this->vk_url.$href);
    
    $photos = array();
    $photos_href = array();
    $title = array();
    $price = array();
    $category = array();
    $description = array();
    $user = array();
    $cat_name = array();
    
    preg_match("|<div class=\"photos\">(.+)</div>|U", $html, $photos);
    preg_match_all("|<a href=\"(.+)\"|U", $photos[1], $photos_href);
    preg_match("|<div class=\"title\">(.+)</div>|U", $html, $title);
    preg_match("|<div class=\"price\">(.+)</div>|U", $html, $price);
    preg_match("|<div class=\"description\">(.+)</div>|U", $html, $description);
    preg_match("|<div class=\"category\">(.+)</div>|U", $html, $category);
    preg_match("|<a class=\"memLink\" href=\"/id(.+)\">(.+)</a>|U", $category[1], $user);
    //preg_match("|:(.+)<br />|U", $category[1], $cat_name);

    $ret = array('photos' => $photos_href[1],
                 'title'  => mysql_real_escape_string($title[1]),
                 'price'  => intval(str_replace(" ", "", strip_tags($price[1]))),
                 'descr'  => mysql_real_escape_string(trim($description[1])),
                 'uname'  => mysql_real_escape_string(trim($user[2])),
                 'uid'    => intval($user[1]));
    return $ret;
  }
  
  public static function isPageExist($href) {
    $el = element(sprintf("SELECT id FROM `element` WHERE `href` = '%s'", mysql_real_escape_string($href)));
    return !empty($el);
  }
  
  protected function moveImages($imgs, $href) {
    if(empty($imgs)) return "";
    $pies = SectionParser::getHrefInfo($href);
    $folder = $this->img_root."/wid_".$pies['id'];
    @mkdir($folder);
    foreach($imgs as $img) {
      $filename = basename($img);
      copy($img, $folder."/".$filename);
    }
    return $folder;
  }
  
  protected function updateSectionCount($sid, $page, $lcount, $cur_sum_count, $ldate) {
    $ldate = self::getDateFromString($ldate);
    if($lcount == 0) {
      $lc = $cur_sum_count - $page + 1;
    } else {
      $lc = $lcount + 1;
    }
    $sql = sprintf("UPDATE `section` SET `last_count` = %u, `last_date` = '%s' WHERE id = %u", $lc, $ldate, $sid);
    query($sql);
    return $lc;
  }
  
  protected function savePage($sid, $href, $date, $city) {
    if(self::isPageExist($href)) return true;//тоже обновим счетчик
    if(!empty($this->ads_count)&&$this->ads_count > 0) {
      $cnt = element('SELECT COUNT(*) FROM `element`');
      //echo $cnt.",".($this->cur_ads_count + $this->ads_count)."!<br>";
      if($cnt >= $this->cur_ads_count + $this->ads_count) {  //520
        exit($this->ads_count.' объявлений успешно загружены. Всего в базе '.$cnt);
      }
    }
    
    $element = $this->getElementInfo($href);
    $sql = sprintf("INSERT INTO `element` (`sid`, `title`, `descr`, `images`, `date`, `href`, `price`, `uname`, `uid`, `city`)" .
                   " VALUES(%u, '%s', '%s', '%s', '%s', '%s', %u, '%s', %u, '%s') ",
                   $sid, $element['title'], $element['descr'], $this->moveImages($element['photos'], $href),
                   self::getDateFromString($date), mysql_real_escape_string($href),
                   $element['price'], $element['uname'], $element['uid'], mysql_real_escape_string($city));
    //echo $sql;
    return query($sql);
  }
  
  private function checkTime() {
    //проверим: не истекло ли время
    if($this->start < time()-$this->refresh_time) {
      $cnt = element('SELECT COUNT(*) FROM `element`');
      exit('В базе '.$cnt.' объявлений. Продолжаем...<meta http-equiv="refresh" content="1">');
    }
  }
  
  private function getPage($last_count, $href) {
    $this->checkTime();
    
    //получим текущее значение числа объяв
    $html = $this->vk->getPageText($this->vk_url.$href);
    $pies = explode('<span style="font-size:8px"> </span>', $html);
    if(count($pies) > 1) { //4ех значное число
      $cnt_left = mb_substr($pies[0], mb_strrpos($pies[0], " ") );
      $cnt_right = mb_substr($pies[1], 0, mb_strpos($pies[1], " ") );
      $count = intval($cnt_left.$cnt_right);
    } else {
      //3ех значное
      $count = intval(mb_substr($html, mb_strpos($html, "Найдено ") + mb_strlen("Найдено "), 3));
    }
    
    //страница = текущее значение - прошлое значение
    if(empty($last_count)) {
      //первый запуск
      $page = 980;
    } else {
      $page = $count - $last_count;
      if($page > 980) $page = 980;
    }
    return array($page, $count);
  }
  
  public function execute() {
    //для каждого раздела
    $sections = select("SELECT id,href,last_count,last_date,name FROM `section` WHERE `sid` IS NOT NULL AND (last_date IS NULL OR last_date < '".date('Y-m-d H:i:s', time()-$this->time_refresh)."') ORDER BY id");
    shuffle($sections);
    $i = 0;
    foreach($sections as $section) {
      $i++;
      if($this->cnt_thread == $i) {
        $i = 1;
      }
      if($this->cur_thread != $i) continue;
      
      $counters = $this->getPage($section['last_count'], $section['href']);
      $page = $counters[0];
      if($page < 1) {
        echo "Раздел ".$section['name']." полностью обновлен!<br>";
        continue; //все распарсили в разделе
      }
      $href = $this->vk_url.$section['href']."&offset=".$page;
      $html = $this->vk->getPageText($href);
      $els = $this->getElementsList($html);
      foreach($els as $el) {
        if($this->savePage($section['id'], $el['href'], $el['date'], $el['city'])) {
          $section['last_count'] = $this->updateSectionCount($section['id'], $page, $section['last_count'], $counters[1], $el['date']);
        }
      }
    }
  }
}
?>